<template>
  <div v-if="loader" class="data-document__loader">
    <ob-loader
      :width="10"
      :height="10"
      :duration="2"
    />
  </div>
  <div v-else class="data-document__data">
    <div v-if="!Object.keys(personalSetting).length" class="data-document-is-empty">
      <p>
        Сейчас настройки документов одинаковы для всех направлений по этому клиенту.
        Добавьте направления, если хотите их настроить индивидуально.
      </p>
      <a @click="$refs['add-modal'].open()">Добавить направление</a>
    </div>
    <div v-else class="data-document-table">
      <ob-table
          ref="ob-table"
          :items="personalSetting"
          :columns="columns"
          :functionalPanel="true"
          :showAddButton="true"
          group-by="locationStartName"
          :group-title-html="groupTitle"
          @add="$refs['add-modal'].open()"
          @select="selectedDirection"
      >
        <div slot="enabled" slot-scope="{ data }">
          <div>
            {{data.item}}
          </div>
        </div>
        <template v-slot:cities="{ data }">
          <i class="icon blue city"/>
          <span class="text"> {{data.item.locationEndName}}</span>
        </template>

        <template v-slot:provision_term="{ data }">
          <ObInput
              v-model="data.item.docSettings.provisionTerm[0].term"
              class="data-documentation__input"
              type="money:0"
              :isConvertMoney="false"
              @blur="changeDirection(data.item)"
          />
        </template>

        <template v-slot:confirm_term="{ data }">
          <ObInput
              v-model="data.item.docSettings.executionConfirmationTerm"
              class="data-documentation__input"
              type="money:0"
              :isConvertMoney="false"
              @blur="changeDirection(data.item)"
          />
        </template>

        <template v-slot:payment_term="{ data }">
          <ObInput
              v-model="data.item.docSettings.paymentTerm"
              class="data-documentation__input"
              type="money:0"
              :isConvertMoney="false"
              @blur="changeDirection(data.item)"
          />
        </template>

        <div slot="deleteRow" slot-scope="{ data }">
          <ob-menu-dropdown :items="getDropdownItems(data)"/>
        </div>
      </ob-table>
    </div>

    <ObModal
        ref="add-modal"
        size="large"
        title="Направление"
        title-second="Добавление "
    >
      <AddModal @closeAddModal="$refs['add-modal'].close()"/>
    </ObModal>
    <ObModal
        ref="delete-modal"
        size="small"
        title="Удалить направление?"
        :is-error="true"
        :is-show-controls="true"
        ok-text="Удалить"
        cancel-text="Отменить"
        @submit="modalDelete(modal_data)"
    >
      <delete-modal :modal_data="modal_data"/>
    </ObModal>
  </div>
</template>

<script>
  import ObLoader from 'common-components/src/obComponents/obLoader';
  import ObTable from 'common-components/src/obComponents/obTable';
  import ObInput from "common-components/src/obComponents/obInput";
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
  import ObModal from 'common-components/src/obComponents/obModal';
  import AddModal from './AddModal';
  import DeleteModal from './DeleteModal';
  import {mapGetters, mapActions} from 'vuex';

  export default {
    name: "PersonalDirections",
    components: {
      ObLoader,
      ObTable,
      ObInput,
      ObMenuDropdown,
      ObModal,
      AddModal,
      DeleteModal
    },
    data() {
      return {
        columns: [
          {
            title: 'куда',
            key: 'city',
            slotName: 'cities'
          },
          {
            title: 'Срок предоставления',
            titleInfo: 'Какой-то поясняющий текст',
            key: 'docSettings.provisionTerm',
            slotName: 'provision_term',
            action: true
          },
          {
            title: 'Срок проверки исполнения',
            titleInfo: 'Какой-то поясняющий текст',
            key: 'docSettings.executionConfirmationTerm',
            slotName: 'confirm_term',
            action: true
          },
          {
            title: 'Срок оплаты',
            titleInfo: 'Какой-то поясняющий текст',
            key: 'docSettings.paymentTerm',
            slotName: 'payment_term',
            action: true
          },
          {
            title: '',
            key: 'delete_row',
            slotName: 'deleteRow',
            sortDisable: true,
            action: true
          }
        ],
        modal_data: {}
      }
    },
    computed: {
      ...mapGetters({
        personalSetting: 'clicarSettings/personal_setting_customer',
        loader: 'clicarSettings/loader',
        list_customers: 'clicarSettings/list_customers',
        client_uuid: 'clicarSettings/client_uuid',
        answerByServer: 'clicarSettings/answerByServer'
      }),

    },
    methods: {
      ...mapActions({
        saveSelectedPersonalSetting: 'clicarSettings/saveSelectedPersonalSetting',
        deleteDirection: 'clicarSettings/deleteDirection'
      }),
      groupTitle(value) {
        return value
      },
      getDropdownItems(data) {
        return [
          {
            title: 'Удалить направление',
            className: 'menu-button-danger',
            method: () => this.onDelete(data.item)
          }
        ]
      },
      onDelete(direction) {
        const contractor = this.list_customers.find(key => key.uuid === this.client_uuid).name;
        this.modal_data = {
          ...direction,
          contractor: contractor
        };
        this.$refs['delete-modal'].open()
      },
      async modalDelete(direction) {
        await this.deleteDirection(direction)
          .then(() => {
            if (this.answerByServer === 'success') {
              this.$notification({
                type: 'system_notification_success',
                message: 'Услугу удалена'
              });
              this.$refs['delete-modal'].close();
            } else if (this.answerByServer === 'error') {
              this.$notification({
                type: 'system_notification_error',
                message: 'Не удается удалить услугу'
              })
            }
          })
      },
      async changeDirection(direction) {
        await this.saveSelectedPersonalSetting(direction)
          .then(() => {
            if (this.answerByServer === 'success') {
              this.$notification({
                type: 'system_notification_success',
                message: 'Услугу изменена'
              });
              this.$refs['delete-modal'].close();
            } else if (this.answerByServer === 'error') {
              this.$notification({
                type: 'system_notification_error',
                message: 'Не удается сохранить изменения'
              })
            }
          })
      },
      selectedDirection({locationStartUuid, locationEndUuid}) {
        this.$router.push({
          path: '/profile__setting/docs',
          query: {
            client: this.client_uuid,
            start: locationStartUuid,
            end: locationEndUuid,
          }
        })
      }
    }
  }
</script>

<style scoped lang="scss">
  .data-document-is-empty {
    text-align: center;
    max-width: 1100px;
    margin: auto;

    p {
      font-size: 24px;
      line-height: 29px;
      letter-spacing: 0.4px;
      color: $color-grey-span;
      margin-bottom: 34px;
    }

    a {
      font-size: 16px;
      line-height: 20px;
      letter-spacing: 0.4px;
      color: $color-blue-navy-blue;
      cursor: pointer;
    }
  }

</style>

<style lang="scss">
  .data-document-table {
    .cities {
      padding-left: 30px;
    }

    .blue {
      color: $color-blue-navy-blue;
      font-size: 16px;
    }

    .text {
      font-size: 14px;
      line-height: 18px;
      letter-spacing: 0.2px;
      color: $color-text-base;
    }

    .obInputRow {
      border: 1px solid $color-grey-border !important;
      box-shadow: inset 0px 3px 6px rgba(25, 30, 50, 0.1) !important;
      border-radius: 3px !important;
    }

    .menu-button-danger {
      color: $color-error;
    }

    .ob-input-wrap.--theme-default {
      border: 1px solid $color-grey-border !important;
      box-shadow: inset 0px 3px 6px rgba(25, 30, 50, 0.1) !important;
      border-radius: 3px !important;
      height: 27px;

      input {
        font-size: 12px;
      }
    }
  }
</style>
